### *** This interface provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.information.metadata

# Interface IdentityInterface

All Superinterfaces:
  `MetadataInterface`, `PublicObjectInterface`, `Remote`

All Known Subinterfaces:
  `IdentityGroupInterface`, `PersonInterface`, `RoleInterface`

All Known Implementing Classes:
  `AllUsersIdentity`, `AuthenticatedIdentity`, `DavPerson`, `PropertyIdentity`, `ReferenceIdentity`, `SelfIdentity`, `UnauthenticatedIdentity`

@SASScope("ALL") @BinaryCompatibilityOnly public interface IdentityInterface extends MetadataInterface

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addExternalIdentity(ExternalIdentityInterface externalIdentity)`
  Add an external identity to the Identity.
  `void`
  `addLogin(LoginInterface login)`
  Add a login to the Identity.
  `String`
  `getDisplayName()`
  Get the identity's display name attribute.
  `String`
  `getEffectiveDispayName()`
  Deprecated.
  Please use the correctly spelled version.
  `String`
  `getEffectiveDisplayName()`
  Get the effective display name for the identity.
  `List<ExternalIdentityInterface>`
  `getExternalIdentities()`
  Get a list of the External Identity objects associated with this Identity.
  `List`
  `getIdentityGroups()`
  Get a List of the IdentityGroups that this Identity belongs to.
  `List<IdentityMembershipInterface>`
  `getIdentityMembershipLevels()`
  Returns the List of IdentityMembershipInterface instances ordered by membership level
  `String`
  `getIdentityType()`
  Return the type of Identity.
  `List`
  `getLogins()`
  Get a list of the Login objects associated with this Identity.
  `List`
  `getUserIds()`
  Get a list of the user id's from the logins associated with this Identity.
  `void`
  `removeExternalIdentity(ExternalIdentityInterface externalIdentity)`
  Remove an external identity from the Identity.
  `void`
  `removeLogin(LoginInterface login)`
  Remove a Login from the Identity.
  `void`
  `setDisplayName(String displayName)`
  Set the identity's display name.

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### getLogins

    List getLogins() throws ServiceException, RemoteException
    Get a list of the Login objects associated with this Identity.
    Returns:
      a List of the Logins.
    Throws:
      `ServiceException` - in the event of a repository failure.
      `RemoteException` - in the event of remote object failure.

  - ### addLogin

    void addLogin(LoginInterface login) throws ServiceException, RemoteException
    Add a login to the Identity.
    Parameters:
      `login` - The Login to add to this Identity.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeLogin

    void removeLogin(LoginInterface login) throws ServiceException, RemoteException
    Remove a Login from the Identity.
    Parameters:
      `login` - The Login to remove from this Identity.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getUserIds

    List getUserIds() throws ServiceException, RemoteException
    Get a list of the user id's from the logins associated with this Identity.
    Returns:
      a List of the user id's.
    Throws:
      `ServiceException` - in the event of repository failure.
      `RemoteException` - in the event of remote object failure.

  - ### getIdentityGroups

    List getIdentityGroups() throws ServiceException, RemoteException
    Get a List of the IdentityGroups that this Identity belongs to.
    Returns:
      A List of IdentityGroupInterface objects that this identity is a direct member of.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getDisplayName

    String getDisplayName() throws ServiceException, RemoteException
    Get the identity's display name attribute.
    Returns:
      The display name, or null if it hasn't been set.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setDisplayName

    void setDisplayName(String displayName) throws ServiceException, RemoteException
    Set the identity's display name. Most users will not have permission to perform this operation. Only user/group administrators will be able to change display names.
    Parameters:
      `displayName` - The identity's new display name.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getEffectiveDispayName

    String getEffectiveDispayName() throws ServiceException, RemoteException
    Deprecated.
    Please use the correctly spelled version.
    Get the effective display name for the identity. If the display name is non-null, that will be returned. Otherwise, the name is returned.
    Returns:
      The effective display name.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getEffectiveDisplayName

    String getEffectiveDisplayName() throws ServiceException, RemoteException
    Get the effective display name for the identity. If the display name is non-null, that will be returned. Otherwise, the name is returned.
    Returns:
      The effective display name.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getIdentityType

    String getIdentityType() throws ServiceException, RemoteException
    Return the type of Identity. This is mostly for internal use. Returns either "Person" or "IdentityGroup". To get the user friendly string, just use getType().
    Returns:
      The identity type string.
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getIdentityMembershipLevels

    List<IdentityMembershipInterface> getIdentityMembershipLevels() throws ServiceException, RemoteException
    Returns the List of IdentityMembershipInterface instances ordered by membership level
    Returns:
      List<`IdentityMembershipInterface`>
    Throws:
      `ServiceException` - If a service level error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### getExternalIdentities

    List<ExternalIdentityInterface> getExternalIdentities() throws ServiceException, RemoteException
    Get a list of the External Identity objects associated with this Identity.
    Returns:
      a List of the External Identities.
    Throws:
      `ServiceException` - in the event of a repository failure.
      `RemoteException` - in the event of remote object failure.

  - ### addExternalIdentity

    void addExternalIdentity(ExternalIdentityInterface externalIdentity) throws ServiceException, RemoteException
    Add an external identity to the Identity.
    Parameters:
      `externalIdentity` - The external identity to add to this Identity.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### removeExternalIdentity

    void removeExternalIdentity(ExternalIdentityInterface externalIdentity) throws ServiceException, RemoteException
    Remove an external identity from the Identity.
    Parameters:
      `externalIdentity` - The external identity to remove from this Identity.
    Throws:
      `ServiceException` - If a repository error occurs.
      `RemoteException` - In the event of remote object failure.